<?php

namespace Gridly\Paginator;

use Pagerfanta\Pagerfanta;

class PagerfantaPaginatorWrapper implements Paginator
{
    /** @var Pagerfanta  */
    private $pagerfantaPaginator;

    /**
     * @param Pagerfanta $paginator
     */
    public function __construct(Pagerfanta $paginator)
    {
        $this->pagerfantaPaginator = $paginator;
    }

    /**
     * @param int $count
     * @return Paginator
     * @throws \Pagerfanta\Exception\NotIntegerMaxPerPageException
     * @throws \Pagerfanta\Exception\LessThan1MaxPerPageException
     */
    public function setItemsPerPage(int $count = 10): Paginator
    {
        $this->pagerfantaPaginator->setMaxPerPage($count);
        return $this;
    }

    /**
     * @param int $page
     * @return iterable
     * @throws \Pagerfanta\Exception\OutOfRangeCurrentPageException
     * @throws \Pagerfanta\Exception\NotIntegerCurrentPageException
     * @throws \Pagerfanta\Exception\LessThan1CurrentPageException
     */
    public function getPageItems(int $page = 1): iterable
    {
        $this->pagerfantaPaginator->setCurrentPage($page);
        return $this->pagerfantaPaginator->getCurrentPageResults();
    }
}
