<?php

namespace Gridly\Renderer\Cli;

use Gridly\Column\Column;
use Gridly\ResultSet;
use Symfony\Component\Console\Command\Command;
use Symfony\Component\Console\Helper\Table;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Output\OutputInterface;

class SymfonyConsoleRendererCommand extends Command
{
    /** @var ResultSet */
    private $data;

    /**
     * @param ResultSet $data
     * @param string|null $name
     */
    public function __construct(ResultSet $data, string $name = null)
    {
        parent::__construct($name);
        $this->data = $data;
    }

    public function configure()
    {
        $this
            ->setName('list')
            ->setDescription('List of entries.')
            ->setHelp('Print a list of entities');
    }

    public function execute(InputInterface $input, OutputInterface $output)
    {
        $table = new Table($output);
        $table->setHeaders($this->data->getHeaders());

        foreach ($this->data->getRows() as $row) {
            $rowData = [];
            /** @var Column $column */
            foreach ($row as $column) {
                $rowData[] = $column->value();
            }
            $table->addRow($rowData);
        }

        $table->render();
    }
}
