<?php

namespace Gridly\Source;

use Doctrine\Common\Collections\Collection;

class DoctrineCollections extends AbstractSource
{
    /**
     * @var Collection
     */
    private $collection;

    /**
     * @param Collection $collection
     */
    public function __construct(Collection $collection)
    {
        $this->collection = $collection;
    }

    /**
     * @param array|null $filters
     * @return AbstractSource
     */
    public function applyFilters(?array $filters = []): AbstractSource
    {
        if (empty($filters)) {
            return $this;
        }

        return $this;
    }

    /**
     * @param int $offset
     * @param int $itemCountPerPage
     * @return iterable
     */
    public function getItems($offset, $itemCountPerPage): iterable
    {
        return $this->collection->slice($offset, $itemCountPerPage);
    }

    /**
     * @return int
     */
    public function count(): int
    {
        return $this->collection->count();
    }
}
